#Avansert Sandwichmetode

# Data

# Geometri (m)

h = 0.34
hxt = 0.14
hxb = 0.14
hyt = 0.14
hyb = 0.14

# Krefter og momenter input (kN/m og kNm/m)

Nx = 0
Ny = 0
Nxy = 0
Mx = 0
My = 0
Mxy = 145

# Material input (MPa)

fcd = 19.8
fsyd = 434

# Resultater

# icrush = 0, no concrete crushing
# icrush = 1, concrete crushing
# Asxt = topp armering parallel til x akse
# Asxb = bunn armering parallel til x akse
# Asyt = topp armering parallel til y akse
# Asyb = bunn armering parallel til y akse

import math
pi = math.pi
tolhe = 0.00001 * h
tolan = (10 / 180) * pi
tomin = tolan
tomax = (pi / 2) - tolan

#Dimensjonerende betongstyrke

fcd1 = 0.85 * (1 - fcd * 1.5 / 250) * fcd * 1000
fcd2 = 0.6 * (1 - fcd * 1.5 / 250) * fcd * 1000

#Utgangspunt for verdier Armeringstilfeller 1,2 og 3

oldat = 0
oldab = 0
Nsxt = 0
Nsyt = 0
Nsxb = 0
Nsyb = 0
icrush = 0
syklus = 0
syklus2 = 0
#syklus legges til for aa erstatte goto funksjonen og for å kunne bryte ut av loop naar vi vil det
arm1 = 0
#arm1 brukes for aa kunne erstatte en goto funksjon paa gitte punkter i koden

# Antatte verdier

at = 0.2 * h
ab = at
hc = h - (ab + at) / 2
Ncxyt = ((h - ab) * Nxy - 2 * Mxy) / 2 / hc
Ncxyb = ((h - at) * Nxy + 2 * Mxy) / 2 / hc
if (Ncxyt == 0):
    Ncxyt = 1e-7
if (Ncxyb == 0):
    Ncxyb = 1e-7

tetat = pi / 4 * abs(Ncxyt) / Ncxyt
tetab = pi / 4 * abs(Ncxyb) / Ncxyb


while True:
	#1100 Start av beregninger, skal aldri lengre tilbake enn hit

	Nct1 = 0
	Ncb1 = 0
	arm1 = 0
	#nullstiller enkelte verdier
	
	#To lag i strekk, iterativ syklus

	hc = h - (ab + at) / 2
	if (tetat != 0):
		Nct = (2 * Mxy - (h - ab) * Nxy) / hc / math.sin(2*tetat)
	if (tetab != 0):
		Ncb = (2 * Mxy + (h - at) * Nxy) / hc / -math.sin(2*tetab)
	

	# if ((abs(tetat) > tomin) & (abs(tetab) < tomax) & (abs(tetab) > tomin) & (abs(tetab) < tomax));
	
	#Spesial tilfeller

	if ((abs(tetat) <= tomin) and (abs(tetab) <= tomin)):
		tetat = 0
		tetab = 0
		Ncb = (My + 0.5 * (h - at) * Ny) / hc
		Nct = Ny - Ncb

	if ((abs(tetat) <= tomin) and (abs(tetab) >= tomax)):
		tetat = 0
		tetab = pi / 2
		Ncb = (Mx + Nx * hxt) / (0.5 * (h - ab) + hxt)
		Nct = (My - Ny * hyb) / (-0.5 * (h - at) - hyb)

	if ((abs(tetat) >= tomax) and (abs(tetab) >= tomax)):
		tetat = pi / 2
		tetab = pi / 2
		Ncb = (Mx + 0.5 * (h - at) * Nx) / hc
		Nct = Nx - Ncb
	
	if ((abs(tetat) >= tomax) and (abs(tetab) <= tomin)):
		tetat = pi / 2
		tetab = 0
		Ncb = (My + Ny * hyt) / (0.5 * (h - ab) + hyt)
		Nct = (Mx - Nx * hxb) / (-0.5 * (h - at) - hxb)

	if (abs(tetat) >= tomax):
		tetat = pi / 2
		Nct = (Mx - Nx * hxb - (0.5 * (h - ab) - hxb) * Ncb * math.sin(tetab)**2) / (-0.5 * (h - at) - hxb)

	if (abs(tetat) <= tomin):
		tetat = 0
		Nct = (My - Ny * hyb - (0.5 * (h - ab) - hyb) * Ncb * math.cos(tetab)**2) / (-0.5 * (h - at) - hyb)

	if (abs(tetab) >= tomax):
		tetab = pi / 2
		Ncb = (Mx + Nx * hxt - (-0.5 * (h - at) + hxt) * Nct * math.sin(tetat)**2) / (0.5 * (h - ab) + hxt)

	if (abs(tetab) <= tomin):
		tetab = 0
		Ncb = (My + Ny * hyt - (-0.5 * (h - at) + hyt) * Nct * math.cos(tetat)**2) / (0.5 * (h - ab) + hyt)
		
	
	#Slutt paa spesialtilfeller

	# 1110 Her starter beregning av krefter og armering, 4 forskjellige tilfeller

	Mct = -0.5 * (h - at) * Nct
	Mcb = 0.5 * (h - ab) * Ncb
	a1 = Nx - Nct * math.sin(tetat) ** 2 - Ncb * math.sin(tetab) ** 2
	b1 = Mx - Mct * math.sin(tetat) ** 2 - Mcb * math.sin(tetab) ** 2
	a2 = Ny - Nct * math.cos(tetat) ** 2 - Ncb * math.cos(tetab) ** 2
	b2 = My - Mct * math.cos(tetat) ** 2 - Mcb * math.cos(tetab) ** 2
	Nsxt = (a1 * hxb - b1) / (hxt + hxb) #I denne formelen er oppgitt i Lourencos formler (hxb+hxb), men er antatt feil
	Nsxb = a1 - Nsxt
	Nsyt = (a2 * hyb - b2) / (hyt + hyb)
	Nsyb = a2 - Nsyt
	
	

	#Sjekker krav til armering (topp og bunn, topp, bunn eller trykk i hele)

	#Trykk i begge lag (Armering1 tilsvarer 1200/2100) 

	def Armering1():
		while True:
			global hc
			global Ncxyb
			global Ncxyt
			global Ncb
			global Nct
			global Nsxt
			global Nsyt
			global Nsxb
			global Nsyb
			global at
			global ab
			global oldat
			global oldab
			global Nct1
			global Ncb1
			global syklus
			global icrush
			global syklus2
			
			hc = h - (ab + at) / 2
			Ncxyb = (Mxy + 0.5 * (h - at) * Nxy) / hc
			Ncxyt = Nxy - Ncxyb
			Ncxb = (Mx + 0.5 * (h - at) * Nx) / hc
			Ncxt = Nx - Ncxb
			Ncyb = (My + 0.5 * (h - at) * Ny) / hc
			Ncyt = Ny - Ncyb
			Ncb = (Ncxb + Ncyb) / 2 - math.sqrt(((Ncxb - Ncyb) / 2) ** 2 + Ncxyb ** 2)
			Nct = (Ncxt + Ncyt) / 2 - math.sqrt(((Ncxt - Ncyt) / 2) ** 2 + Ncxyt ** 2)
			Ncb1 = (Ncxb + Ncyb) / 2 + math.sqrt(((Ncxb - Ncyb) / 2) ** 2 + Ncxyb ** 2)
			Nct1 = (Ncxt + Ncyt) / 2 + math.sqrt(((Ncxt - Ncyt) / 2) ** 2 + Ncxyt ** 2)
			alfa = Ncb1 / Ncb
			Kb = (1 + 3.65 * alfa) / (1 + alfa) ** 2
			alfa = Nct1 / Nct
			Kt = (1 + 3.65 * alfa) / (1 + alfa) ** 2
			#Lagre gamle verdier for lengde av ytre lag
	
			oldat = at
			oldab = ab
			
			#Nye ytre lag verdier
			
			ab = -Ncb / fcd1 / Kb
			at = -Nct / fcd1 / Kt
			
			
			if ((Nct1 > 1e-3) or (Ncb1 > 1e-3)): #da skal vi gaa tilbake til 1100
				break
			
			#sjekk for crushing
				
			if ((at + ab) > h): #da skal vi gaa til 4200
				icrush = 1
				syklus2 = 1
				break
			
			#convergency check
				
			if ((abs(oldab - ab) > tolhe) and (abs(oldat - at) > tolhe)):
				#da skal vi tilbake til def armering1 eller 1200/2100
				continue
			
			#end of full compression cycle
			
			icrush = 0
				
			Nsxt = 0
			Nsyt = 0
			Nsxb = 0
			Nsyb = 0
			
			#goto 4200
			#Dette betyr at det ikke er behov for armering, crushing oppstaar ikke og kreftene settes lik null
			
			syklus = 1
			
			break
		
	if ((Nsxt <= 1e-3) and (Nsyt <= 1e-3) and (Nsxb <= 1e-3) and (Nsyb <= 1e-3)):
		Armering1()
	
	#Legger til en del betingelser slik at koden folger goto funksjonene fra Lourenco
	
	if ((Nct1 > 1e-3) or (Ncb1 > 1e-3)): #da skal vi gaa tilbake til 1100
		continue
	
	if (syklus2 == 1): #da skal vi gaa til 4200
		icrush = 1
		break
		
	if (syklus == 1): #da skal vi gå til 4200
		break

	#Slutt paa trykk i begge lag


	#Trykk i ovre lag (Armering2 tilsvarer 2200/3100)

	def Armering2():
		while True:
			global hc
			global Ncxyt
			global Ncb
			global Nct
			global Nsxt
			global Nsyt
			global Nsxb
			global Nsyb
			global at
			global ab
			global Nct1
			global Ncb1
			global oldab
			global oldat
			global tetab
			global Mcb
			global syklus
			global icrush
			global arm1
			global syklus2
			
			hc = h - (ab + at) / 2
			Ncb = -(Nxy * (h - at) + 2 * Mxy) / hc / math.sin(2 * tetab)
			
			#Spesial tilfeller
			
			if (abs(tetab) <= tomin):
				tetab = 0
				Ncb = (My + 0.5 * (h - at) * Ny) / hc
			
			if (abs(tetab) >= tomax):
				tetab = pi / 2
				Ncb = (Mx + 0.5 * (h - at) * Nx) / hc
			
			#Slutt paa spesialtilfeller
			
			Mcb = 0.5 * (h - ab) * Ncb
			a1 = Nx - Ncb * math.sin(tetab) ** 2
			b1 = Mx - Mcb * math.sin(tetab) ** 2
			a2 = Ny - Ncb * math.cos(tetab) ** 2
			b2 = My - Mcb * math.cos(tetab) ** 2
			Nsxb = (a1 * 0.5 * (h - at) + b1) / (hxb + 0.5 * (h - at))
			Nsyb = (a2 * 0.5 * (h - at) + b2) / (hyb + 0.5 * (h - at))
			
			
			if ((Nsxb <= 1e-3) and (Nsyb <= 1e-3)):
				arm1 = 1
				break #Her vil vi gaa til 1200/2100 som jeg har kalt Armering1, arm1 brukes for aa ikke bruke nsxb og nsyb utenfor loopen
			
			if (Nsxb <= -1e-3):
				tetab = math.atan((2 * Mx + (h - at) * Nx) / (0.5 * (h - at) * Ncb + Mcb) / math.sin(2 * tetab))
				continue #Her vil vi gaa tilbake til Armering2 som tilsvarer 2200/3100
			
			
			if (Nsyb <= -1e-3):
				tetab = math.atan((Mcb + 0.5 * (h - at) * Ncb) * math.sin(2 * tetab) / (2 * My + (h - at) * Ny))
				continue #Her vil vi gaa tilbake til Armering2 som tilsvarer 2200/3100
			
			Ncxyt = Nxy + Ncb * math.sin(tetab) * math.cos(tetab)
			Ncxt = a1 - Nsxb
			Ncyt = a2 - Nsyb
			Nct = (Ncxt + Ncyt) / 2 - math.sqrt(((Ncxt - Ncyt) / 2) ** 2 + Ncxyt ** 2)
			
			#Lagre gamle verdier for at og ab
			
			oldat = at
			oldab = ab

			#Oppdater ytre lag verdier for at og ab
			
			Nct1 = (Ncxt + Ncyt) / 2 + math.sqrt(((Ncxt - Ncyt) / 2) ** 2 + Ncxyt ** 2)
			alfa = Nct1 / Nct
			Kt = (1 + 3.65 * alfa) / (1 + alfa) ** 2
			at = -Nct / fcd1 / Kt
			ab = -Ncb / fcd2
			
			#Re-check av trykk i topplag
			
			if (Nct1 > 1e-3):
				break
				#go to 1100 tilbake til start
			
			#Sjekk concrete crushing
			
			if ((at + ab) > h):
				icrush = 1
				syklus2 = 1
				break
				#go to 4200
				
			#Convergence check
			
			if ((abs(oldab - ab) > tolhe) and (abs(oldat - at) > tolhe)):
				continue #go to 3100
			
			#Slutt paa trykk i ovre lag syklusen
			
			icrush = 0
			
			Nsxt = 0
			Nsyt = 0
			
			
			syklus = 1
			#goto 4200
			
		
			break
		
	if ((Nsxt <= 1e-3) and (Nsyt <= 1e-3) and (Nsxb > 1e-3) and (Nsyb > 1e-3)):
		Armering2()
		
	if (arm1 == 1):
		Armering1()
		
	if (Nct1 > 1e-3):
		continue
		
	if (syklus2 == 1):
		icrush = 1
		break
	
	if (syklus == 1): #da skal vi gå til 4200
		break
		

	#Trykk i nedre lag (Armering3 tilsvarer 3200/4100)

	def Armering3():
		while True:
			global hc
			global Ncxyb
			global Ncb
			global Nct
			global Nsxt
			global Nsyt
			global Nsxb
			global Nsyb
			global at
			global ab
			global Nct1
			global Ncb1
			global oldat
			global oldab
			global tetat
			global syklus
			global icrush
			global arm1
			global syklus2
		
			hc = h - (ab + at) / 2
			Nct = -(Nxy * (h - ab) - 2.0 * Mxy) / hc / math.sin(2 * tetat)
			
			#Spesial tilfeller
			
			if (abs(tetat) <= tomin):
				tetat = 0
				Nct = (My - 0.5 * (h - ab) * Ny) / -hc
			
			if (abs(tetat) >= tomax):
				tetat = pi / 2
				Nct = (Mx - 0.5 * (h - ab) * Nx) / -hc
				
			#Slutt paa spesialtilfeller
			
			Mct = -0.5 * (h - at) * Nct
			a1 = Nx - Nct * math.sin(tetat) ** 2
			b1 = Mx - Mct * math.sin(tetat) ** 2
			a2 = Ny - Nct * math.cos(tetat) ** 2
			b2 = My - Mct * math.cos(tetat) ** 2
			Nsxt = (a1 * 0.5 * (h - ab) - b1) / (hxt + 0.5 * (h - ab))
			Nsyt = (a2 * 0.5 * (h - ab) - b2) / (hyt + 0.5 * (h - ab))
			
			if ((Nsxt <= 1e-3) and (Nsyt <= 1e-3)):
				arm1 = 1
				break #go to 1200/2100
				
			if (Nsxt <= -1e-3):
				tetat = math.atan((2 * Mx - (h - ab) * Nx) / (Mct - 0.5 * (h - ab) * Nct) / math.sin(2 * tetat))
				continue #goto Armering3 eller 3200/4100
			
			if (Nsyt <= -1e-3):
				tetat = math.atan((Mct - 0.5 * (h - ab) * Nct) * math.sin(2 * tetat) / (2 * My - (h - ab) * Ny))
				continue #goto Armering3 eller 3200/4100
			
			
			Ncxyb = Nxy + Nct * math.sin(tetat) * math.cos(tetat)
			Ncxb = a1 - Nsxt
			Ncyb = a2 - Nsyt
			Ncb = (Ncxb + Ncyb) / 2 - math.sqrt(((Ncxb - Ncyb) / 2) ** 2 + Ncxyb ** 2)
			
			#Lagre gamle verdier for ytrelag
			
			oldat = at
			oldab = ab
			
			#oppdaterer ytre lag med nye verdier
			
			Ncb1 = (Ncxb + Ncyb) / 2 + math.sqrt(((Ncxb - Ncyb) / 2) ** 2 + Ncxyb ** 2)
			alfa = Ncb1 / Ncb
			Kb = (1 + 3.65 * alfa) / (1 + alfa) ** 2
			at = -Nct / fcd2
			ab = -Ncb / fcd1 / Kb
			
			#Re-check om trykk i nedre lag
			
			if (Ncb1 > 1e-3):
				break
				#goto 1100/start
		
			#Sjekk concrete crushing
			
			if ((at + ab) > h):
				icrush = 1
				syklus2 = 1
				break
				#goto 4200
			
			#Convergence check
			
			if ((abs(oldab - ab) > tolhe) and (abs(oldat - at) > tolhe)):
				continue #goto Armering3/3200/4100
				
			
			#Slutt paa trykk i nedrelag syklus
			
			icrush = 0
			
			Nsxb = 0
			Nsyb = 0
			
			syklus = 1
			
			break
		
	if ((Nsxb <= 1e-3) and (Nsyb <= 1e-3) and (Nsxt > 1e-3) and (Nsyt > 1e-3)):
		Armering3() #goto Armering3 som er 3200/4100 i Lourenco
	
	if (arm1 == 1):
		Armering1()	#goto 1200
	
	if (Ncb1 > 1e-3):
		continue #start på nytt
	
	if (syklus2 == 1):
		icrush = 1
		break #goto 4200
		
	if (syklus == 1):
		break
	
	#Strekk i begge lag
	if ((Nsxt <= -1e-3)):
		tetat = math.atan(2 * (Mx - hxb * Nx - (Mcb - Ncb * hxb) * math.sin(tetab) ** 2) / (Mct - Nct * hxb) / math.sin(2 * tetat))
		continue #goto 1100
		
	if ((Nsyt <= -1e-3)):
		tetat = math.atan(math.sin(2 * tetat) * (Mct - Nct * hyb) / 2 / (My - hyb * Ny - (Mcb - Ncb * hyb) * math.cos(tetab) ** 2))
		continue #go to 1100

	if ((Nsxb <= -1e-3)):
		tetab = math.atan(2 * (Mx + hxt * Nx - (Mct + Nct * hxt) * math.sin(tetat) ** 2) / (Mcb + Ncb * hxt) / math.sin(2 * tetab))
		continue #goto 1100
		
	if ((Nsyb <= -1e-3)):
		tetab = math.atan(math.sin(2 * tetab) * (Mcb + Ncb * hyt) / 2 / (My + hyt * Ny - (Mct + Nct * hyt) * math.cos(tetat) ** 2))
		continue #goto 1100
		
	
		
	oldat = at
	oldab = ab
		
	#Oppdatere verdier for ytre lag

	at = -Nct / fcd2
	ab = -Ncb / fcd2
	
	#Sjekker concrete crushing
		

	if ((at + ab) > h):
		icrush = 1
		break
		#goto 4200
			
	if ((abs(oldab - ab) > tolhe) and (abs(oldat - at) > tolhe)):
		continue #go to 1100

	icrush = 0
	
	
	break #goto 4200
	

	

#Beregning av armering (Siste del, kalt 4200 i Lourenco)

Asxt = Nsxt * 1000 / fsyd
Asxb = Nsxb * 1000 / fsyd
Asyt = Nsyt * 1000 / fsyd
Asyb = Nsyb * 1000 / fsyd


tetaTT = (tetat * 180 / pi)
tetaBB = (tetab * 180 / pi)

print ("Vinkler")
print ("tetat", "tetab")
print (tetaTT, tetaBB)

print ("diverse verdier")
print ("Nct", "Ncb", "Mct", "Mcb", "at", "ab")
print (Nct, Ncb, Mct, Mcb, at, ab)

print ("Armering")
print ("Asxt", "Asxb","Asyt", "Asyb")
print (Asxt, Asxb, Asyt, Asyb)

print ("Krefter")
print ("Nsxt", "Nsxb","Nsyt", "Nsyb")
print (Nsxt, Nsxb, Nsyt, Nsyb)

if (icrush == 1):
	print("knusing")
if (icrush == 0):
	print("ikke knusing")



	
		
	

		


			
		
		
		
	 
	
	















