# Reinforcment in concrete plate and shells

# Data

# Geometri (m)

h = 1.5
hxt = 0.67
hxb = 0.67
hyt = 0.67
hyb = 0.67

# Krefter og momenter input (kN/m og kNm/m)

Nx = -7748
Ny = -3865
Nxy = -54
Mx = 4274
My = 1950
Mxy = -41

# Material input (MPa)

fcd = 19.8
fsyd = 435

# Resultater

# icrush = 0, no concrete crushing
# icrush = 1, concrete crushing
# Asxt = topp armering parallel til x akse
# Asxb = bunn armering parallel til x akse
# Asyt = topp armering parallel til y akse
# Asyb = bunn armering parallel til y akse

import math
pi = math.pi
tolhe = 0.00001 * h
tolan = (10 / 180) * pi
tomin = tolan
tomax = (pi / 2) - tolan

#Dimensjonerende betongstyrke

fcd1 = 0.85 * (1 - fcd * 1.5 / 250) * fcd * 1000
fcd2 = 0.6 * (1 - fcd * 1.5 / 250) * fcd * 1000

#Utgangspunt for verdier Armeringstilfeller 1,2 og 3

Nct1 = 0
Ncb1 = 0
oldat = 0
oldab = 0
Nsxt = 0
Nsyt = 0
Nsxb = 0
Nsyb = 0

# Antatte verdier

at = 0.2 * h
ab = at
hc = h - (ab + at) / 2
Ncxyt = ((h - ab) * Nxy - 2 * Mxy) / 2 / hc
Ncxyb = ((h - at) * Nxy + 2 * Mxy) / 2 / hc
if (Ncxyt == 0):
    Ncxyt = 1e-7
if (Ncxyb == 0):
    Ncxyb = 1e-7

tetat = pi / 4 * abs(Ncxyt) / Ncxyt
tetab = pi / 4 * abs(Ncxyb) / Ncxyb



while True:
	#1100 Start av beregninger, skal aldri lengre tilbake enn hit

	#To lag i strekk, iterativ syklus

	hc = h - (ab + at) / 2
	Nct = (2 * Mxy - (h - ab) * Nxy) / hc / math.sin(2*tetat)
	Ncb = (2 * Mxy + (h - at) * Nxy) / hc / -math.sin(2*tetab)

	# if ((abs(tetat) > tomin) & (abs(tetab) < tomax) & (abs(tetab) > tomin) & (abs(tetab) < tomax));

	
	#Slutt paa spesialtilfeller

	# 1110 Her starter beregning av krefter og armering, 4 forskjellige tilfeller

	Mct = -0.5 * (h - at) * Nct
	Mcb = 0.5 * (h - ab) * Ncb
	a1 = Nx - Nct * math.sin(tetat) ** 2 - Ncb * math.sin(tetab) ** 2
	b1 = Mx - Mct * math.sin(tetat) ** 2 - Mcb * math.sin(tetab) ** 2
	a2 = Ny - Nct * math.cos(tetat) ** 2 - Ncb * math.cos(tetab) ** 2
	b2 = My - Mct * math.cos(tetat) ** 2 - Mcb * math.cos(tetab) ** 2
	Nsxt = (a1 * hxb - b1) / (hxt + hxb) #I denne formelen er oppgitt i Lourencos formler (hxb+hxb), men er antatt feil
	Nsxb = a1 - Nsxt
	Nsyt = (a2 * hyb - b2) / (hyt + hyb)
	Nsyb = a2 - Nsyt
	
	

	#Sjekker krav til armering (topp og bunn, topp, bunn eller trykk i hele)

	#Trykk i begge lag (Armering1 tilsvarer 1200/2100) 

	def Armering1():
		while True:
			global hc
			global Ncxyb
			global Ncxyt
			global Ncb
			global Nct
			global Nsxt
			global Nsyt
			global Nsxb
			global Nsyb
			global at
			global ab
			global oldat
			global oldab
			global Nct1
			global Ncb1
			
			hc = h - (ab + at) / 2
			Ncxyb = (Mxy + 0.5 * (h - at) * Nxy) / hc
			Ncxyt = Nxy - Ncxyb
			Ncxb = (Mx + 0.5 * (h - at) * Nx) / hc
			Ncxt = Nx - Ncxb
			Ncyb = (My + 0.5 * (h - at) * Ny) / hc
			Ncyt = Ny - Ncyb
			Ncb = (Ncxb + Ncyb) / 2 - math.sqrt(((Ncxb - Ncyb) / 2) ** 2 + Ncxyb ** 2)
			Nct = (Ncxt + Ncyt) / 2 - math.sqrt(((Ncxt - Ncyt) / 2) ** 2 + Ncxyt ** 2)
			Ncb1 = (Ncxb + Ncyb) / 2 + math.sqrt(((Ncxb - Ncyb) / 2) ** 2 + Ncxyb ** 2)
			Nct1 = (Ncxt + Ncyt) / 2 + math.sqrt(((Ncxt - Ncyt) / 2) ** 2 + Ncxyt ** 2)
			alfa = Ncb1 / Ncb
			Kb = (1 + 3.65 * alfa) / (1 + alfa) ** 2
			alfa = Nct1 / Nct
			Kt = (1 + 3.65 * alfa) / (1 + alfa) ** 2
			#Lagre gamle verdier for lengde av ytre lag
			
			oldat = at
			oldab = ab
			
			#Nye ytre lag verdier
			
			ab = -Ncb / fcd1 / Kb
			at = -Nct / fcd1 / Kt
			
			
			if ((Nct1 > 1e-3) or (Ncb1 > 1e-3)): #da skal vi gaa tilbake til 1100
				break
				
			#sjekk for crushing
				
			if ((at + ab) > h): #da skal vi gaa til 4200
				icrush = 1
				break
				
			#convergency check
				
			if ((abs(oldab - ab) > tolhe) and (abs(oldat - at) > tolhe)):
				#da skal vi tilbake til def armering1 eller 1200/2100
				continue
			
			#end of full compression cycle
			
			icrush = 0
				
			Nsxt = 0
			Nsyt = 0
			Nsxb = 0
			Nsyb = 0
			
			#goto 4200
			#Dette betyr at det ikke er behov for armering, crushing oppstaar ikke og kreftene settes lik null
			
			break
		
	if ((Nsxt <= 1e-3) and (Nsyt <= 1e-3) and (Nsxb <= 1e-3) and (Nsyb <= 1e-3)):
		Armering1()
		
	if ((Nct1 > 1e-3) or (Ncb1 > 1e-3)):
		break
		
	if ((abs(oldab - ab) > tolhe) and (abs(oldat - at) > tolhe)):
		#da skal vi tilbake til def armering1 eller 1200/2100
		break

		

